use arduino_hal::{
    hal::port::Dynamic,
    port::{
        mode::{Input, PullUp},
        Pin,
    },
};

pub const BUTTON_COUNT: usize = 8;

pub struct Button {
    pub index: usize,
    pub pin: Pin<Input<PullUp>, Dynamic>,
    pub is_low: bool,
}

impl Button {
    pub fn check_state<F>(&mut self, mut f: F)
    where
        F: FnMut(usize, bool),
    {
        if self.pin.is_high() {
            if self.is_low {
                self.is_low = false;

                f(self.index, true);
            }
        } else {
            if !self.is_low {
                self.is_low = true;

                f(self.index, false);
            }
        }
    }
}
